<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . '/user_management/check_username_availability.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'admin_api/academic_session/functions/registration_functions.php';
require_once $base_path_to_learning . 'faculty_api/modules/students/student_functions.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//dynemic db
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

require_once $base_path_to_learning . "vendor/autoload.php";
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';
// require_once $base_path_to_learning_resources . 'lib/common_modules/students/functions.php';
require_once $base_path_to_learning . "faculty_api/faculty_function/common_faculty_function.php";
require_once $base_path_to_learning . "principal_api/principal_function/principal_function.php";

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);

if (
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['jwt_token']) or !checkIfIssetAndNotEmpty($postdata['jwt_token'])

) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, ["teacher"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific,$version, $updated_time, $userid, $institution_id);

$function_type = trim($postdata['function_type']);
    if (isset($postdata['class_id']) and !empty($postdata['class_id']) and trim($postdata['class_id'])) {
        $class_id = trim($postdata['class_id']);
    } else {
        $class_id = "all";
    }
    if (isset($postdata['section_id']) and !empty($postdata['section_id']) and trim($postdata['section_id'])) {
        $section_id = trim($postdata['section_id']);
    } else {
        $section_id = "all";
    }


$sql_codes = $conn_rjllearning_specific->prepare("SELECT id FROM faculty_info WHERE userid = ? AND institution_id = ? AND branch_id = ?");
$sql_codes->execute(array($userid, $institution_id, $branch_id));
$result_faculty = $sql_codes->fetch(PDO::FETCH_ASSOC);

if ($result_faculty === false) {
    errorreturn("Faculty Not Found.");
}

$faculty_id = $result_faculty['id'];
$faculty_data = getClassSectionSubjectsAndInChargeRoles($conn_rjllearning, $conn_rjllearning_specific, $institution_id, $userid);

$class_section_subjects  = $faculty_data['class_section_subjects'];
$class_incharge_roles = $faculty_data['class_incharge_roles'];
$staff_access_modules = $faculty_data['staff_access_modules'];

$check_faculty_status = checkFacultyModuleGranted($function_type, $class_section_subjects, $class_incharge_roles, $staff_access_modules, $class_id, $section_id, null, $conn_rjllearning);
if($check_faculty_status == false){
        errorreturn("Access denied: You do not have the required permissions.");
}
if ($postdata['function_type']  == "fetch_students") {
    $check_academic_confirmation_id = CheckAcademicSession($conn_rjllearning_specific, $institution_id);

    if ($check_academic_confirmation_id != true) {
        errorreturn("Access denied. Academic session not active.");
    }

    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }

    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;

    $additionaldata = array();
    // $additionaldata = ['id', 'stock_name', 'current_qty', 'parent_group'];
    //$additionaldata = ['id','institution_id','branch_id','admission_number','username','name','mobile','email','dob','gender','fathername','mothername','address_line_1','city','pincode','caste','nationality','nationality_proof_number'];
    $additionaldata = ['id', 'institution_id', 'branch_id', 'class_id', 'section_id', 'admission_id', 'admission_number', 'name', 'mobile', 'email', 'dob', 'fathername', 'gender', 'student_profile_image', 'can_activate', 'user_id','username'];

    $additionaldata = array_merge($additionaldata, $postdata['additional_data']);
    $limit = $postdata['limit'];

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
    } else {
        $offset = null;
    }
    $export_type = (isset($postdata['export_type']) and !empty($postdata['export_type'])) ? trim($postdata['export_type']) : null;
    if (isset($export_type)) { // true // value check should either be spreadsheet pdf 
        if ($export_type == 'spreadsheet') {
            require_once $base_path_to_learning . 'admin_api/modules/students/export/excel/export_manage_students_excel.php';
        } else  if ($export_type == 'pdf') {
            require_once $base_path_to_learning . 'admin_api/modules/students/export/pdf/export_manage_students_pdf.php';
        } else  if ($export_type == 'print') {
            require_once $base_path_to_learning . 'admin_api/modules/students/export/print/export_manage_students_print.php';
        }
    } else {

        $success['data'] = GetBasicStudentsDetail($conn_rjllearning_specific, $institution_id, $branch_id, $class_id, $section_id,$search_string, $limit, $offset, $additionaldata);
        successreturn($success);
    }
}
